Broken import of simple marker line
Status: Closed

Priority: Severe/Regression

Assignee: Arunmozhi P

Category: Symbology

Affected QGIS version:master Regression?: No

Operating System: all Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 16022

Description

Symbol layer "Marker line" import is broken, both for lines and polygons outline. Point markers and SVG fills works fine.

See attached screenshots:

    -  correct_import_18.png — import in 1.8.0

    -  broken_import_master.png — same symbols imported in master

To test use attached symbol: put vegetation_grounds folder in SVG search path and then try to import styles from test.xml.

Tagged as High because it works fine in previous version and this is major issue in using complex styles

Associated revisions

Revision 8b981975 - 2012-12-27 04:18 PM - Arunmozhi 

Fixes #6897

Revision be315746 - 2012-12-27 11:29 PM - Nathan Woodrow

Merge pull request #368 from tecoholic/6897

Fixes #6897. Handle import of old symbols.

History

#1 - 2012-12-19 05:22 AM - Giovanni Manghi

is this a regression?

#2 - 2012-12-19 05:25 AM - Alexander Bruy

Giovanni Manghi wrote:

is this a regression?

I think yes. It works fine in 1.8.0 and 1.7.x. Not sure, but seems this introduced by GSoC work

#3 - 2012-12-19 05:36 AM - Giovanni Manghi
- Priority changed from High to Severe/Regression

anyway seems really a regression, so I'm tagging this as blocker.

#4 - 2012-12-19 09:52 PM - Arunmozhi P

The issue is with the new nesting technique of the symbols. Previously the only a single level of nesting was possible, the XML structure was modified to

accommodate multiple nesting.

Hence the symbols with nesting, like the marker line, in version before GSoC (guess < 1.8) will be incompatible with the code after GSoC (I guess 1.9) But

export and import done only in 1.8 or only in 1.9 should work fine.

#5 - 2012-12-19 09:55 PM - Arunmozhi P

I am testing the uniqueness of the problem for "Marker Line" though. Will update.

#6 - 2012-12-20 01:14 PM - Arunmozhi P

Here is a python script that someone can use for cross importing the symbols from old installations to the new. https://gist.github.com/4344168

#7 - 2012-12-20 11:48 PM - Alexander Bruy

Arunmozhi P wrote:

Here is a python script that someone can use for cross importing the symbols from old installations to the new. https://gist.github.com/4344168

Thanks! But seems this script don't understand cyrillic symbols in XML. Just tried to convert style from first post and get error

$ python symbol_convert.py test.xml 

Traceback (most recent call last):

  File "symbol_convert.py", line 62, in <module>

    convertXMLStructure( sys.argv[1] )

  File "symbol_convert.py", line 30, in convertXMLStructure

    indom = parse( filepath )

  File "/usr/lib/python2.7/xml/dom/minidom.py", line 1920, in parse

    return expatbuilder.parse(file)

  File "/usr/lib/python2.7/xml/dom/expatbuilder.py", line 924, in parse

    result = builder.parseFile(fp)

  File "/usr/lib/python2.7/xml/dom/expatbuilder.py", line 207, in parseFile

    parser.Parse(buffer, 0)

xml.parsers.expat.ExpatError: not well-formed (invalid token): line 4, column 24

Line 4 looks like

<symbol alpha="1" name="Болота проходимые_100к" outputUnit="MM" type="fill">
#8 - 2012-12-27 02:29 PM - Nathan Woodrow

- Status changed from Open to Closed

Fixed in changeset commit:"be3157462aabe680c623f3daf39ef44cbd774b5c".

Files

test.zip 2.17 KB 2012-12-19 Alexander Bruy

correct_import_18.png 4.07 KB 2012-12-19 Alexander Bruy

broken_import_master.png 8.6 KB 2012-12-19 Alexander Bruy
